/*
 File: parallel_parser_ph_th.h
 Date and Time: Fri Jan 30 18:55:19 2015 
*/
#ifndef __parallel_parser_ph_th_h__
#define __parallel_parser_ph_th_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "lint_balls.h"
#include "identifier.h"
#include "o2_sdc.h"
#include "o2_code_end.h"
#include "la_expr_src.h"
  
extern yacco2::Thread_entry ITH_parallel_parser_ph_th;

extern yacco2::State S1_Cparallel_parser_ph_th;
namespace NS_parallel_parser_ph_th {
yacco2::THR _YACCO2_CALL_TYPE
TH_parallel_parser_ph_th(yacco2::Parser* Caller);// called thread
yacco2::THR_result _YACCO2_CALL_TYPE
PROC_TH_parallel_parser_ph_th(yacco2::Parser* Caller);// called thread's twin the procedure
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[12];
};
class Cparallel_parser_ph_th: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rparallel_parser_phrase_ = 569//start_of_rule_list + 0
    ,rhs1_Rparallel_parser_phrase_ = 1
   ,R_Rlint_ = 570//start_of_rule_list + 2
    ,rhs1_Rlint_ = 2
    ,rhs2_Rlint_ = 3
   ,R_Ropen_par_ = 571//start_of_rule_list + 4
    ,rhs1_Ropen_par_ = 4
    ,rhs2_Ropen_par_ = 5
   ,R_Rclose_par_ = 572//start_of_rule_list + 6
    ,rhs1_Rclose_par_ = 6
    ,rhs2_Rclose_par_ = 7
   ,R_Rparameters_ = 573//start_of_rule_list + 8
    ,rhs1_Rparameters_ = 8
   ,R_Rpp_thread_fnct_phrase_ = 574//start_of_rule_list + 10
    ,rhs1_Rpp_thread_fnct_phrase_ = 9
   ,R_Rpp_thread_fnct_ = 575//start_of_rule_list + 12
    ,rhs1_Rpp_thread_fnct_ = 10
    ,rhs2_Rpp_thread_fnct_ = 11
    ,rhs3_Rpp_thread_fnct_ = 12
   ,R_Rpp_thread_fnct_id_ = 576//start_of_rule_list + 14
    ,rhs1_Rpp_thread_fnct_id_ = 13
    ,rhs2_Rpp_thread_fnct_id_ = 14
    ,rhs3_Rpp_thread_fnct_id_ = 15
   ,R_R3asterics_ = 577//start_of_rule_list + 16
    ,rhs1_R3asterics_ = 16
    ,rhs2_R3asterics_ = 17
   ,R_Rpp_la_bndary_phrase_ = 578//start_of_rule_list + 18
    ,rhs1_Rpp_la_bndary_phrase_ = 18
   ,R_Rpp_la_bndary_ = 579//start_of_rule_list + 20
    ,rhs1_Rpp_la_bndary_ = 19
    ,rhs2_Rpp_la_bndary_ = 20
    ,rhs3_Rpp_la_bndary_ = 21
   ,R_Rpp_la_bndary_stc_ = 580//start_of_rule_list + 22
    ,rhs1_Rpp_la_bndary_stc_ = 22
    ,rhs2_Rpp_la_bndary_stc_ = 23
    ,rhs3_Rpp_la_bndary_stc_ = 24
  };
  //no of la sets = 4
  //no of states = 44
  Cparallel_parser_ph_th();
  ~Cparallel_parser_ph_th();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[25];
  
    public:
    T_parallel_parser_phrase* parallel_parser_phrase_;
  
 };
struct Rparallel_parser_phrase;
struct Rlint;
struct Ropen_par;
struct Rclose_par;
struct Rparameters;
struct Rpp_thread_fnct_phrase;
struct Rpp_thread_fnct;
struct Rpp_thread_fnct_id;
struct R3asterics;
struct Rpp_la_bndary_phrase;
struct Rpp_la_bndary;
struct Rpp_la_bndary_stc;
struct Rparallel_parser_phrase:public yacco2::CAbs_lr1_sym {
  Rparallel_parser_phrase(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rlint:public yacco2::CAbs_lr1_sym {
  Rlint(yacco2::Parser* P);
  public:
};

struct Ropen_par:public yacco2::CAbs_lr1_sym {
  Ropen_par(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rclose_par:public yacco2::CAbs_lr1_sym {
  Rclose_par(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rparameters:public yacco2::CAbs_lr1_sym {
  Rparameters(yacco2::Parser* P);
  public:
};

struct Rpp_thread_fnct_phrase:public yacco2::CAbs_lr1_sym {
  Rpp_thread_fnct_phrase(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rpp_thread_fnct:public yacco2::CAbs_lr1_sym {
  Rpp_thread_fnct(yacco2::Parser* P);
 
        public: T_parallel_thread_function* pp_fnct_;
    
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Rpp_thread_fnct_id:public yacco2::CAbs_lr1_sym {
  Rpp_thread_fnct_id(yacco2::Parser* P);
 public:T_identifier* id_;
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct R3asterics:public yacco2::CAbs_lr1_sym {
  R3asterics(yacco2::Parser* P);
  public:
  void sr2();
};

struct Rpp_la_bndary_phrase:public yacco2::CAbs_lr1_sym {
  Rpp_la_bndary_phrase(yacco2::Parser* P);
 
		public:T_parallel_la_boundary* pp_la_bndary_;
	
  public:
  void sr1();
};

struct Rpp_la_bndary:public yacco2::CAbs_lr1_sym {
  Rpp_la_bndary(yacco2::Parser* P);

		public:T_parallel_la_boundary* pp_la_bndary_;

  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Rpp_la_bndary_stc:public yacco2::CAbs_lr1_sym {
  Rpp_la_bndary_stc(yacco2::Parser* P);
 
		public:
		T_la_expr_src* la_exp_;
	
  public:
  void sr1();
  void sr2();
  void sr3();
};

} // end of namespace

#endif
